/*
 * Copyright (c) 2003 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "qt_os.h"

//---------------------------------------------------------------------------
bool QToffscreen::OpenMovie(char *szPathName)
{
	OSErr err;

	err = NewMovieFromWinPathname(szPathName);

	return (err == noErr);
}
//---------------------------------------------------------------------------
OSErr QToffscreen::NewMovieFromWinPathname(char *pathName)
{
	FSSpec	fileSpec;
	OSErr	err;

	if (m_hMovie.theMovie != NULL) DisposeMovieHandle(&m_hMovie);

	NativePathNameToFSSpec(pathName, &fileSpec, 0L);

	err = OpenMovieFile(&fileSpec, &m_hMovie.movieRefNum, fsRdWrPerm);
	if (err)
	{
		err = OpenMovieFile(&fileSpec, &m_hMovie.movieRefNum, fsRdPerm);
	}

	if (!err)
	{
		err = NewMovieFromFile(&m_hMovie.theMovie, m_hMovie.movieRefNum, &m_hMovie.movieResId, NULL, newMovieActive, NULL);
	}

	if (err)
	{
		if (m_hMovie.theMovie)
		{
			DisposeMovie(m_hMovie.theMovie);
			m_hMovie.theMovie = NULL;
		}
	}

	return err;
}
//---------------------------------------------------------------------------
void QToffscreen::DisposeMovieHandle(MovieHandle *hMovie)
{
	if (hMovie->movieRefNum)
	{
		CloseMovieFile(hMovie->movieRefNum);
	}

	if (hMovie->theMovie)
	{
		DisposeMovie(hMovie->theMovie);
	}
}
//---------------------------------------------------------------------------
bool QToffscreen::GetMoviePreview(HGLOBAL *hMem)
{
	PicHandle hPic = NULL;

	hPic = GetMoviePosterPict(m_hMovie.theMovie);

	if (hPic == NULL) return false;

	*hMem = GetDIBFromPICT(hPic);
	KillPicture(hPic);

	return true;
}
//---------------------------------------------------------------------------
